PROGRAM MatrixMultiplication

!!!!!!!!!!!!!!!!!!!!!!!
!Объявление параметров!
!!!!!!!!!!!!!!!!!!!!!!!

!перемножаемые матрицы
real, allocatable :: LmatrixL(:,:)[:], LmatrixR(:,:)[:],LmatrixRes(:,:)[:]
real, allocatable :: matrixL(:,:), matrixR(:,:),matrixRes(:,:)
!индексы
integer :: matrix_size,i,j,blok_size,images_num,blok_dimention,t
integer :: stolb,temp2,temp3,strok, err

!timer variable
integer, parameter :: DP = selected_real_kind(15)
real :: T1,T2,Seconds2, Seconds
integer :: pulses, PPS

!!!!!!!!!!!!!!!!!!!!!!!
!Объявление параметров!
!!!!!!!!!!!!!!!!!!!!!!!

!Чтение параметров командной строки
character(LEN=10) :: r
integer :: count
              
count = command_argument_count()
IF (count < 4) STOP

CALL GET_COMMAND_ARGUMENT(1,r)
read(r,*) nrepeat

CALL GET_COMMAND_ARGUMENT(2,r)
read(r,*) matrix_size

CALL GET_COMMAND_ARGUMENT(4,r)
read(r,*) param2

!Параметры запуска
me = this_image()
images_num = num_images()!количество  images
blok_size = int(matrix_size/images_num)!размер блока
n = matrix_size

allocate (LmatrixL(matrix_size,matrix_size)[*])
allocate (LmatrixR(matrix_size,matrix_size)[*])
allocate (LmatrixRes(matrix_size, matrix_size)[*])

!print *, n
!print *, blok_size

do irep=1, nrepeat

    !!!!!!!!!!!!!!!!!!!!!!
    !Инициализаия матрицы!
    !!!!!!!!!!!!!!!!!!!!!!
    if (me==1) then
        allocate (matrixL(matrix_size,matrix_size))
        allocate (matrixR(matrix_size,matrix_size))
        allocate (matrixRes(matrix_size,matrix_size))
        
        
        
        do i=1, matrix_size
            do j=1, matrix_size
                matrixL(i,j)=cos(real(i))*cos(real(j))
                matrixR(i,j)=sin(real(i))*sin(real(j))
                matrixRes(i,j) = 0.0
                
            end do
        end do
    end if

    sync all
    
    if (me==1) then
        CALL SYSTEM_CLOCK(COUNT=Pulses,COUNT_RATE=PPS)
        T1 = REAL(Pulses,DP)/PPS
    end if
    
    sync all
    
    if (me==1) then
        
        do k = 1, images_num
            LmatrixL(:,:)[k]=matrixL(matrix_size,matrix_size)
            LmatrixR(:,:)[k]=matrixR(matrix_size,matrix_size)
        end do
    endif
	
	do i=1, matrix_size
		do j=1, matrix_size
			LmatrixRes(i,j)[me] = 0.0
		end do
	end do
    
    sync all
        do j=1, n
            do i=1, blok_size
                do k=1, n
                    LmatrixRes(i,j)[me]=    &
                      LmatrixRes(i,j)[me] + &
                      LmatrixL(i  + (me - 1) * blok_size,k)[me] * LmatrixR(k,j)[me]
                end do
            end do
        end do
    
    if (me==1) then
        do j=1, n
            do i=blok_size * images_num, matrix_size 
                do k=1, n
                    matrixRes(i,j)= matrixRes(i,j) + matrixL(i,k) * matrixR(k,j)
                end do
            end do
        end do
    endif
    
    sync all
    
    if (me==1) then
        do k = 1, images_num
            do j=1, n
                do i=1, blok_size
                    matrixRes(i + (k-1) * blok_size,j)=LmatrixRes(i,j)[k]
                end do
            end do
        end do
    endif
    
    sync all

    if (me==1) then
        !конец таймера 1
        CALL SYSTEM_CLOCK(COUNT=Pulses,COUNT_RATE=PPS)
        T2 = REAL(Pulses,DP)/PPS
        Seconds=T2-T1
        
        print *, Seconds
        deallocate (matrixL)
        deallocate (matrixR)
        deallocate (matrixRes)
        
    end if

end do

deallocate (LmatrixL)
deallocate (LmatrixR)
deallocate (LmatrixRes)

END PROGRAM MatrixMultiplication
