﻿/*
//  Реализация алгоритма последовательного умножения 
//  квадратной матрицы А на вектор b.
//
// API
// int SerialMatrixVectorMultiplication(const double* pMatrix, const double* pVector,
//                                           double* pResult, const int Size);
//
//  Input:
//
//     +  const double* pMatrix - исходная матрица;
//     +  const double* pVector - исходный вектор;
//     +  const int Size - размер исходной квадратной матрицы;
//
//  Output:
//
//     +  double* pResult - результат перемножения;
//
//  Result:
//     + функция возвращает значение типа int - код завершения функции.
// Код завершения программы.
*/

int SerialMatrixVectorMultiplication(const double* pMatrix, const double* pVector, double* pResult, const int Size)
{
  int i, j;
  assert(pMatrix);
  assert(pVector);
  assert(pResult);
  assert(Size>0);
  for(i = 0; i < Size; i++)
  {
      pResult[i] = 0.0;
      for(j = 0; j< Size; j++)
      {
          pResult[i] += pMatrix[i*Size+j] * pVector[j];
      }
  }
  return 0;
}