PROGRAM MatrixMultiplication

!!!!!!!!!!!!!!!!!!!!!!!
!Объявление параметров!
!!!!!!!!!!!!!!!!!!!!!!!

!перемножаемые матрицы
real, allocatable :: matrixL(:,:), matrixR(:,:),matrixRes(:,:)
!индексы
integer :: nrepeat, irep, n, i, j, k, param2, err

!timer variable
integer, parameter :: DP = selected_real_kind(15)
real :: T1,T2,Seconds2, Seconds
integer :: pulses, PPS

!!!!!!!!!!!!!!!!!!!!!!!
!Объявление параметров!
!!!!!!!!!!!!!!!!!!!!!!!

!Чтение параметров командной строки
character(LEN=10) :: r
integer :: count
              
count = command_argument_count()
IF (count < 4) STOP

CALL GET_COMMAND_ARGUMENT(1,r)
read(r,*) nrepeat

CALL GET_COMMAND_ARGUMENT(2,r)
read(r,*) n

CALL GET_COMMAND_ARGUMENT(4,r)
read(r,*) param2

!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!последовательное умножение! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!

allocate (matrixL(n,n))
allocate (matrixR(n,n))
allocate (matrixRes(n,n))
do irep=1, nrepeat
	do i=1, n
		do j=1, n
			matrixL(i,j)=cos(real(i))*cos(real(j))
			matrixR(i,j)=sin(real(i))*sin(real(j))
			matrixRes(i,j) = 0.0
		end do
	end do

	!начало таймера 1
	CALL SYSTEM_CLOCK(COUNT=Pulses,COUNT_RATE=PPS)
	T1 = REAL(Pulses,DP)/PPS
	do j=1, n
		do i=1, n
			do k=1, n
				matrixRes(i,j)=matrixRes(i,j)+matrixL(i,k)*matrixR(k,j)
			end do
		end do
	end do

	!конец таймера 2
	CALL SYSTEM_CLOCK(COUNT=Pulses,COUNT_RATE=PPS)
	T2 = REAL(Pulses,DP)/PPS

	Seconds2=T2-T1
	write(*,*) Seconds2
end do
	
deallocate (matrixR)
deallocate (matrixL)
deallocate (matrixRes)

END PROGRAM MatrixMultiplication
